#include <assert.h>
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <string>
#include <stdlib.h>
#include <time.h>
#include "pathplanner.h"
#include "util.h"

PathPlanner *initPlanner(char *workspaceName, double initPenetration, 
			 int initNumNodes);

int main(int argc, char *argv[])
{
  PathPlanner *planner;
  char inFileName[20];

  verbose_input = true;
  verbose_output = true;

  int initNumNodes;
  double depth;

  cout << time(0) << endl;

  unsigned long seed;
  cout << "Enter a seed: ";
  cin >> seed;
  srand48(seed);

  //  cout << "What obstacle file would you like? ";
  //cin >> inFileName;

  cout << "How many nodes would you like initially? ";
  cin >> initNumNodes;
  cout << "How deep? ";
  cin >> depth;

  bool stats;
  cin >> stats;

  planner = initPlanner("narrow.off", depth, initNumNodes--); 
  while (stats && planner->connected()) {
    srand48(seed);
    planner = initPlanner("narrow.off", depth, initNumNodes--); 
  }

  cout << endl << endl << "Min start: " << ++initNumNodes << endl;

  return(0);
}

PathPlanner *initPlanner(char *workspaceName, double depth, 
			 int initNumNodes)
{
  ifstream workspaceIn(workspaceName);
  assert(workspaceIn);
  PathPlanner *pathPlanner = new PathPlanner(workspaceIn, 1);

  pathPlanner->makePenNodes(initNumNodes);
  pathPlanner->makePenPaths(.5);
  pathPlanner->saveNodesVect("nodes_0.vect");
  pathPlanner->savePathsVect("paths_0.vect");
  pathPlanner->regrowObstacles(depth);
  //  pathPlanner->saveNodesVect("nodes_1.vect");
  pathPlanner->savePathsVect("paths_1.vect");
  return pathPlanner;
}

