#include "util.h"

bool verbose_input;
bool verbose_output;

istream& operator>>(istream& in, Point2& point) {
  double x, y, z;

  in >> x >> y >> z;
  point = point2(x, y);

  return in;
}

double area2(const Point2& a, const Point2& b, const Point2& c) {
  return ((a.x * b.y - a.y * b.x + 
	   a.y * c.x - a.x * c.y + 
	   b.x * c.y - c.x * b.y)/2);
}

bool left(const Point2& a, const Point2& b, const Point2& c) {
  return (area2(a, b, c) > 0);
}

bool leftOn(const Point2& a, const Point2& b, const Point2& c) {
  return (area2(a, b, c) >= 0);
}

double max(double a, double b) {
  return (a > b ? a : b);
}

double min(double a, double b) {
  return (a < b ? a : b);
}
